import { FreezeFrame } from "../types/UE4";
import { PeerConfig, VideoSettings } from "../types/WebRTC";
import { AspectRatio } from "../utils/AspectRatio";
import { ARTCPlayer } from "./webrtc/ARTCPlayer";
import { Stats } from "./webrtc/stats";
import Input from "../input/Input";
import WebRTCClient from "./WebRTCClient";
export default class RTCPlayer extends ARTCPlayer {
    static ShowPackageDataWithStats: boolean;
    static ShowMaxResolution: boolean;
    private readonly webrtc_client;
    readonly input: Input;
    private get socket();
    get freezeFrame(): FreezeFrame;
    aspectRatio: AspectRatio;
    constructor(config: PeerConfig, audioVideo: VideoSettings, webrtc_client: WebRTCClient);
    onWebRtcOffer(offer: RTCSessionDescriptionInit): void;
    onWebRtcCandidate(candidate: RTCIceCandidate): void;
    onDataChannelConnected(): void;
    onDataChannelClosed(): void;
    private ready;
    onVideoInitialized(): void;
    onVideoPlay(): void;
    onDataChannelMessage(data: ArrayBufferLike): void;
    private printInterval;
    private nextPrintDuration;
    private reportIncomingVideoSize;
    onAggregatedStats(aggregatedStats: Stats): void;
}
