import Keycloak from "keycloak-js";
import WebRTCClient from "./WebRTCClient";
import RTCPlayer from "./RTCPlayer";
export declare function setWithExpiry(key: string, value: unknown, ttl?: number): void;
export declare function willExpire(key: string): boolean;
export declare function getWithExpiry<T>(key: string): T | null;
export default class Socket {
    private no_auth;
    private _keycloak?;
    /** Set this flag to false, to be able to locally test queue. */
    private rememberSession;
    private webrtc_client;
    player: RTCPlayer | undefined;
    private get input();
    private _ws;
    get ws(): WebSocket;
    private url;
    constructor(url: string, no_auth?: boolean, _keycloak?: Keycloak);
    private onWebSocketMessages;
    get keycloak(): Promise<Keycloak>;
    private get keycloakToken();
    init(webrtc_client: WebRTCClient, reconnect?: boolean): Promise<void>;
    ready(): boolean;
    send(data: string | ArrayBuffer | ArrayBufferView | Blob): void;
    close(closeCode: number, reason: string): void;
    defaultAttempts: number;
    defaultReconnectDelay: number;
    reconnect: {
        attempts: number;
        attemptsLeft: number;
        inProgress: boolean;
        delay: number;
        lastReconnectTime: number;
        reconnectBlocked: boolean;
    };
    resetReconnectAttempts: () => void;
    reconnectAttempt(): void;
    blockReconnect(): void;
}
