import AWebRTCClient from "./webrtc/AWebRTCClient";
import { TInputOptions } from "../types/UE4";
import { Snackbar, InitCallback, WebRTCClientProps, Autoplay, ApplicationResponse } from "../types/WebRTC";
import Input from "../input/Input";
import { PlayerResolution } from "./webrtc/PlayerResolution";
declare type ContainerName = "video" | "container" | "sizeContainer";
export default class WebRTCClient extends AWebRTCClient {
    readonly playerResolution: PlayerResolution;
    renderStatsEnabled: boolean;
    get renderStats(): boolean;
    private get player();
    get input(): Input | undefined;
    shouldShowPlayOverlay: boolean;
    /** Setting onOrientationChange method to a bind variable, for adding & removing event listeners. */
    private onOrientationChanged;
    /** Setting setResolution method to a bind variable, for adding & removing event listeners. */
    private onResize;
    private delayOrientationChange;
    inputOptions: TInputOptions;
    loader: (val: boolean, disconnected?: boolean) => void;
    snackbar?: Snackbar;
    videoInitializeCallback: InitCallback;
    applicationResponse: ApplicationResponse;
    videoRef: any;
    audioRef: any;
    touchRegistered: boolean;
    disconnectedDueToAfk: boolean;
    forceVideoToFitContainer: boolean;
    extmapAllowMixed: boolean;
    autoplay: Autoplay;
    playOverlay: boolean;
    verbosityLevel: number;
    updateQueueData: WebRTCClientProps["updateQueueData"];
    sendResolutionOnResize: boolean;
    unauthorizedFallback: () => unknown;
    sendLetter: WebRTCClientProps["sendLetter"];
    keycloakUrl: any;
    clientId: any;
    constructor(props: WebRTCClientProps);
    setAfk(): void;
    containersStyles: {
        sizeContainer: {};
        container: {
            width: string;
            height: string;
        };
        video: {};
    };
    setContainersStyles: (object: HTMLElement, containerName: ContainerName, stylesObj: any) => void;
    revertToLastSavedContainersStyles: () => void;
    adjustContainerFit: () => void;
    initializeVideo: () => void;
    private timeOutFunctionId;
    private cancelResize;
    private setupDomListeners;
    closeWebsocket(reason: string, noReconnect?: boolean): void;
    load(touchSupport?: boolean): void;
    onOrientationChange(): void;
    landscapeFullscreenMode(): void;
    play(): void;
    sendInputData(data: ArrayBuffer): void;
    zoom(value: number): void;
    sendQualityConsoleCommands(descriptor: {
        PrioritiseQuality: number;
        LowBitrate: number;
        HighBitrate: number;
    }): void;
}
export { type Snackbar } from "../types/WebRTC";
