import { Stats } from "./stats";
import { PeerConfig, VideoSettings } from "../../types/WebRTC";
import WebRTCClient from "../WebRTCClient";
export declare abstract class ARTCPlayer {
    private readonly cfg;
    private pcClient;
    private dcClient;
    private tnClient;
    private readonly dataChannelOptions;
    abstract onWebRtcOffer(offer: RTCSessionDescriptionInit): void;
    abstract onWebRtcCandidate(candidate: RTCIceCandidate): void;
    abstract onDataChannelConnected(): void;
    abstract onDataChannelClosed(): void;
    abstract onDataChannelMessage(data: ArrayBufferLike): void;
    abstract onVideoInitialized(): void;
    abstract onVideoPlay(): void;
    abstract onAggregatedStats(aggregatedStats: Stats): void;
    private aggregateStatsIntervalId;
    private aggregatedStats;
    video: HTMLVideoElement;
    audio: HTMLAudioElement;
    private videoSettings;
    private extmapAllowMixed;
    constructor(webrtc_client: WebRTCClient, config: PeerConfig, audioVideo: VideoSettings);
    private createWebRtcAudio;
    private createWebRtcVideo;
    private handleOnTrack;
    private setupDataChannel;
    private onicecandidate;
    private handleCreateOffer;
    private setupPeerConnection;
    handleCandidateFromServer(iceCandidate: RTCIceCandidate): void;
    createOffer(): void;
    receiveAnswer(answer: RTCSessionDescriptionInit): void;
    close(): void;
    send(data: ArrayBuffer): void;
    private getStats;
    aggregateStats(checkInterval: number): void;
}
