import { TStreamInfo, Size } from "../../types/ImportSignallingData";
import { PlayerStyle } from "../../types/Style";
import { descriptor, Descriptor } from "../../types/UE4";
import { AwayFromKeyboard } from "../../utils/AwayFromKeyboard";
import { Dispatcher } from "../../utils/event/Dispatcher";
import { AEvent, EventTypes } from "../../utils/event/Events";
import Dom from "../Dom";
import Socket from "../Socket";
import { PlayerResolution } from "./PlayerResolution";
import type { OrientationZoom, ExtraSettings } from "../../types/WebRTC";
export default abstract class AWebRTCClient {
    protected settings: ExtraSettings;
    playerResolution: PlayerResolution;
    static PrintInputs: boolean;
    private static next;
    websocketClosed: boolean;
    orientationZoom: OrientationZoom;
    private static get Next();
    private id;
    get identifier(): string;
    playerStyle: PlayerStyle;
    private _address;
    get address(): string;
    sessionId: string;
    shareId: string;
    private _packageId;
    get packageId(): string;
    private _streamInfo;
    set streamInfo(streamInfo: TStreamInfo);
    get streamInfo(): TStreamInfo;
    get hasStreamInfo(): boolean;
    afk: AwayFromKeyboard;
    abstract setAfk(): void;
    dom: Dom;
    style: {
        additional: string;
        cursor: string;
    };
    private _socket;
    get socket(): Socket;
    readonly events: Dispatcher;
    dispatch(event: AEvent | EventTypes | (new () => AEvent)): void;
    constructor(address: string, packageId: string, sessionId: string, shareId: string, settings: ExtraSettings);
    private initDomHelper;
    abstract play(): void;
    abstract sendInputData(data: ArrayBuffer): void;
    emitCommand(_descriptor: Descriptor): void;
    emitDescriptor(messageType: descriptor.ToUE4Message, _descriptor: Descriptor): void;
    emitUIInteraction: (_descriptor: Descriptor) => void;
    requestQualityControl(): void;
    setStreamResolution(size: Size): void;
}
