export interface Stats {
    id: string;
    type: string;
    trackIdentifier: string;
    kind: string;
    isRemote: boolean;
    mediaType: string | "video";
    timestamp: number;
    framesDecoded: number;
    bytesReceived: number;
    packetsLost: number;
    bytesReceivedStart: number;
    framesDecodedStart: number;
    timestampStart: number;
    bitrate: number;
    lowBitrate: number;
    highBitrate: number;
    avgBitrate: number;
    framerate: number;
    lowFramerate: number;
    highFramerate: number;
    avgframerate: number;
    framesDropped: number;
    framesReceived: number;
    framesDroppedPercentage: number;
    frameHeight: number;
    frameWidth: number;
    frameHeightStart: number;
    frameWidthStart: number;
    currentRoundTripTime: number;
}
export default function stats(stats: RTCStatsReport, _oldStats?: Stats): Promise<Stats>;
export declare function calculateReceivedBytes(aggregatedStats: Stats): [string, number];
export declare function calculateRuntime(aggregatedStats: Stats): string;
