import { FreezeFrame } from "../types/UE4";
import RTCPlayer from "../entities/RTCPlayer";
import WebRTCClient from "../entities/WebRTCClient";
export default class Engine {
    static PrintInputs: boolean;
    protected readonly player: RTCPlayer;
    protected readonly webrtc_client: WebRTCClient;
    x: number;
    y: number;
    hiddenInput: HTMLInputElement | undefined;
    editTextButton: HTMLButtonElement | undefined;
    freezeFrame: FreezeFrame;
    get video(): HTMLVideoElement;
    constructor(webrtc_client: WebRTCClient, player: RTCPlayer);
    emitMouseMove(x: number, y: number, deltaX: number, deltaY: number): void;
    emitMouseWheel(delta: number, x: number, y: number): void;
    emitMouseDown(button: number, x: number, y: number): void;
    emitMouseUp(button: number, x: number, y: number): void;
}
