/** Any of these Messages is prefixed with "LL: " to enable filtering them.
 * One could also use the enum to directly check for them and take action.
 */
export declare enum LoveLetter {
    bypassSuccess = "LL: Bypass succeeded, about to connect.",
    bypassFailed = "LL: Bypass failed, something went wrong.",
    bypassNoStream = "LL: Bypass succeeded, no stream available.",
    bypassError = "LL: Bypass error.",
    signallingConnectionEstablished = "LL: Signalling connection established.",
    signallingConnectClient = "LL: Start connection to stream signalling.",
    startInstance = "LL: No stream found, let's try start one only for you.",
    startInstanceWithRId = "LL: Directly starting stream - debugging.",
    searchResource = "LL: Searching for resources to start the stream.",
    foundResource = "LL: Found resource to start the stream.",
    commandedStart = "LL: Starting stream.",
    requestInstance = "LL: Connecting to cloud.",
    searchSession = "LL: Let's try to find your session.",
    searchInstance = "LL: Searching for stream.",
    connectClient = "LL: Reserving stream.",
    awaitConnectClient = "LL: Waiting for stream.",
    ticketRegistered = "LL: Ticket registered.",
    ticketDestroyed = "LL: Ticket destroyed.",
    checkToken = "LL: Checking token.",
    shareIdError = "LL: Share error.",
    shareIdDoesNotExist = "LL: Share unknown.",
    shareIdExpired = "LL: Share expired.",
    shareIdInactive = "LL: Share inactive.",
    shareIdUsageCapReached = "LL: Share inactive, usage cap reached.",
    authorizationError = "LL: Authorization error.",
    scissors = "LL: Don't run with scissors.",
    noProjectIdTableFlip = "LL: No projectId? (\u25E0\u203F\u25E0 ) (\u256F\u0CA0_\u0CA0)\u256F\uFE35 \u253B\u2501\u253B",
    tableFlip = "LL: (\u256F\u00B0\u25A1\u00B0\uFF09\u256F\uFE35 \u253B\u2501\u253B",
    shrug = "LL: \u00AF\\_(\u30C4)_/\u00AF",
    wat = "LL: \u0CA0_\u0CA0",
    destroy_projectNotDistributed = "LL: The requested project is not distributed.",
    destroy_projectNotYetDistributed = "LL: The project is currently in distribution. Please retry in a few minutes.",
    destroy_projectHasNeverBeenReleased = "LL: Project unavailable. This project has never been released.",
    destroy_projectHasNeverBeenReleasedYet = "LL: Project unavailable. Seems to be available soon.",
    destroy_projectLastReleaseFailed = "LL: Project unavailable. Last release failed.",
    destroy_instanceTimeout = "LL: Project didn't start in time.",
    easterEgg_MayTheForce = "LL: May the force be with you. ;)",
    easterEgg_NotProjectLookingFor = "LL: This is not the project you are looking for. ;)",
    easterEgg_BendingTheSpoon = "LL: Bending the spoon. ;)",
    easterEgg_AdjustFluxCapacitor = "LL: Adjusting the flux capacitor. ;)",
    easterEgg_ExecuteGitForcePush = "LL: Executing 'git push --force'. ;)",
    easterEgg_WaitForDaenerys = "LL: Waiting for Daenerys to say all her titles ... ;)",
    easterEgg_ReleasingTheKraken = "LL: Releasing the Kraken. ;)",
    easterEgg_BadFeeling = "LL: Uhh ... I have a bad feeling about that. ;)",
    easterEgg_TestPixelsForCovid = "LL: Testing pixels for covid-19."
}
export declare function LoveLetterEasterEgg(): LoveLetter | undefined;
