export declare enum ToClientMessage {
    QualityControlOwnership = 0,
    Response = 1,
    Command = 2,
    FreezeFrame = 3,
    UnfreezeFrame = 4,
    VideoEncoderAvgQP = 5
}
export declare type Descriptor = unknown;
export declare namespace descriptor {
    enum ToUE4Message {
        /** ******************************************************************* */
        IFrameRequest = 0,
        RequestQualityControl = 1,
        MaxFpsRequest = 2,
        AverageBitrateRequest = 3,
        StartStreaming = 4,
        StopStreaming = 5,
        /** ******************************************************************* */
        UIInteraction = 50,
        Command = 51,
        KeyDown = 60,
        KeyUp = 61,
        KeyPress = 62,
        MouseEnter = 70,
        MouseLeave = 71,
        MouseDown = 72,
        MouseUp = 73,
        MouseMove = 74,
        MouseWheel = 75,
        TouchStart = 80,
        TouchEnd = 81,
        TouchMove = 82
    }
    function ToBuffer(messageType: ToUE4Message, descriptor: Descriptor): ArrayBuffer;
}
export declare class FreezeFrame {
    receiving: boolean;
    size: number;
    jpeg: Uint8Array | undefined;
    height: number;
    width: number;
    valid: boolean;
    freezeFrameOverlay: HTMLImageElement;
    constructor();
    private setupFreezeFrameOverlay;
    showFreezeFrameOverlay(): void;
    invalidateFreezeFrameOverlay(): void;
}
export declare enum ControlScheme {
    LockedMouse = 0,
    HoveringMouse = 1
}
export declare type TInputOptions = {
    controlScheme: ControlScheme;
    suppressBrowserKeys: boolean;
    fakeMouseWithTouches: boolean;
};
export declare enum MouseButton {
    MainButton = 0,
    AuxiliaryButton = 1,
    SecondaryButton = 2,
    FourthButton = 3,
    FifthButton = 4
}
export declare enum MouseButtonsMask {
    PrimaryButton = 1,
    SecondaryButton = 2,
    AuxiliaryButton = 4,
    FourthButton = 8,
    FifthButton = 16
}
