import { Size } from "../types/ImportSignallingData";
export declare module PlayerAspectBiggerThenVideoAspect {
    /** Signed XY deltas are the ratio (-1.0..1.0) along a viewport axis,
     * quantized into an int16 (-32767..32767).
     */
    function normalizeAndQuantizeSigned(element: Element, x: number, y: number, ratio: number): {
        x: number;
        y: number;
    };
    function unquantizeAndDenormalizeUnsigned(element: Element, x: number, y: number, ratio: number): {
        x: number;
        y: number;
    };
    /** Unsigned XY positions are the ratio (0.0..1.0) along a viewport axis,
     * quantized into an uint16 (0..65536).
     */
    function normalizeAndQuantizeUnsigned(element: Element, x: number, y: number, ratio: number): {
        inRange: boolean;
        x: number;
        y: number;
    };
}
export declare module VideoAspectBiggerThenPlayerAspect {
    /** Signed XY deltas are the ratio (-1.0..1.0) along a viewport axis,
     * quantized into an int16 (-32767..32767).
     */
    function normalizeAndQuantizeSigned(element: Element, x: number, y: number, ratio: number): {
        x: number;
        y: number;
    };
    function unquantizeAndDenormalizeUnsigned(element: Element, x: number, y: number, ratio: number): {
        x: number;
        y: number;
    };
    /** Unsigned XY positions are the ratio (0.0..1.0) along a viewport axis,
     * quantized into an uint16 (0..65536).
     */
    function normalizeAndQuantizeUnsigned(playerElement: Element, x: number, y: number, ratio: number): {
        inRange: boolean;
        x: number;
        y: number;
    };
}
export declare class AspectRatio {
    playerElement: Element;
    videoElement: HTMLVideoElement;
    constructor(playerElement: Element, videoElement: HTMLVideoElement);
    /** Signed XY deltas are the ratio (-1.0..1.0) along a viewport axis,
     * quantized into an int16 (-32767..32767).
     */
    normalizeAndQuantizeSigned(x: number, y: number, viedoRes: Size | undefined): {
        x: number;
        y: number;
    };
    unquantizeAndDenormalizeUnsigned(x: number, y: number, viedoRes: Size | undefined): {
        x: number;
        y: number;
    };
    /** Unsigned XY positions are the ratio (0.0..1.0) along a viewport axis,
     * quantized into an uint16 (0..65536).
     */
    normalizeAndQuantizeUnsigned(x: number, y: number, viedoRes: Size | undefined): {
        x: number;
        y: number;
    };
    normalizeTouchScreen(touchX: number, touchY: number, element: HTMLVideoElement): {
        inRange: boolean;
        x: number;
        y: number;
    };
}
/** Checks if the window has an landscape-aspect-ratio. */
export declare function isLandscape(): boolean;
export declare function round(num: number, decimals: number): number;
export declare function capScale(size: Size, max: Size): Size;
