export { KeyDictionaries } from "./keyboard-inputs/dictionaries";
/** Maps a known keyboard key from string to number or from number to string, depending on the input.
 * This Method shall be used with KeyboardEvent.key for example, or to check a number index for a readable key name.
 */
export declare function MapKey<Key extends string | number, Output extends Key extends string ? number : string>(key: Key): Output | undefined;
export declare function isBrowserKey<Key extends string | number>(key: Key): boolean;
export declare const MessageType: {
    /** ******************************************************************* */
    IFrameRequest: number;
    RequestQualityControl: number;
    FpsRequest: number;
    AverageBitrateRequest: number;
    StartStreaming: number;
    StopStreaming: number;
    LatencyTest: number;
    RequestInitialSettings: number;
    /** ******************************************************************* */
    UIInteraction: number;
    Command: number;
    KeyDown: number;
    KeyUp: number;
    KeyPress: number;
    MouseEnter: number;
    MouseLeave: number;
    MouseDown: number;
    MouseUp: number;
    MouseMove: number;
    MouseWheel: number;
    TouchStart: number;
    TouchEnd: number;
    TouchMove: number;
    GamepadButtonPressed: number;
    GamepadButtonReleased: number;
    GamepadAnalog: number;
};
export declare const SpecialKeyCodes: {
    BackSpace: number;
    Shift: number;
    Control: number;
    Alt: number;
    RightShift: number;
    RightControl: number;
    RightAlt: number;
};
