import { AEvent, EventTypes, TEvent } from "./Events";
export declare type Handler<Event extends AEvent | unknown = AEvent> = (event: Event) => void;
export declare type Listener = {
    remove: () => boolean;
    isRegistered: () => boolean;
    handler: Handler<any>;
};
export declare type HandlerDict = {
    [Key in EventTypes]?: Handler[];
};
export declare class Dispatcher {
    createStack?: boolean;
    private handlers;
    private requiredListeners?;
    private static duckTypeEventTypes;
    dispatch(event: AEvent | EventTypes | (new () => AEvent)): void;
    addListener<Event extends TEvent<C>, C extends AEvent>(event: Event, handler: Handler<Event extends AEvent ? Event : unknown>): Listener;
    /** Returns true on successful removal, false if not. */
    removeListener<Event extends TEvent<C>, C extends AEvent>(event: Event, handler: Handler<Event extends AEvent ? Event : unknown>): boolean;
    setupRequiredListeners(...events: Array<TEvent<any>>): Dispatcher;
    checkRequiredListeners(): {
        missing: string[];
        added: string[];
    };
}
