import { TStreamInfo } from "../../types/ImportSignallingData";
export declare enum EventTypes {
    generic = 0,
    NoStreamAvailable = 1,
    VideoInitialized = 2,
    VideoPlay = 3,
    RTCPlayerCreated = 4,
    RTCVideoReady = 5,
    StreamInfoReceived = 6,
    DataChannelClosed = 7,
    WebsocketClosed = 8,
    Unauthorized = 9,
    AFK_Warn = 10,
    AFK_Error = 11,
    AFK_Action = 12,
    AFK_Abort = 13
}
export interface IEvent {
    readonly type: EventTypes;
}
export declare type TEvent<C extends AEvent> = ((new (...args: any[]) => C) & {
    readonly Type: EventTypes;
}) | AEvent | EventTypes;
export declare abstract class AEvent implements IEvent {
    protected static _Type?: EventTypes;
    static get Type(): EventTypes;
    get type(): EventTypes;
    protected _type?: EventTypes;
    stack?: string;
}
export declare class Generic extends AEvent {
    constructor(type: EventTypes);
}
export declare enum RTCVideoReadyState {
    none = 0,
    dataChannelReady = 1,
    resolution = 2
}
export declare class RTCVideoReady extends AEvent {
    readonly state: RTCVideoReadyState;
    protected static _Type: EventTypes;
    protected _type: EventTypes;
    constructor(state: RTCVideoReadyState);
}
export declare class StreamInfoReceived extends AEvent {
    readonly streamInfo: TStreamInfo;
    protected static _Type: EventTypes;
    protected _type: EventTypes;
    constructor(streamInfo: TStreamInfo);
}
export declare class Unauthorized extends AEvent {
    readonly reason: string;
    protected static _Type: EventTypes;
    protected _type: EventTypes;
    constructor(reason: string);
}
